' *****************************************************************
' *                                                               *
' *       Copyright (c) Fast Corporation, 2010                    *
' *                                                               *
' *   All Rights Reserved.  Unpublished rights  reserved  under   *
' *   the copyright laws of the Japan.                            *
' *                                                               *
' *   The software contained on this media  is  proprietary  to   *
' *   and  embodies  the  confidential  technology  of  Fast      *
' *   Corporation.  Possession, use,  duplication  or             *
' *   dissemination of the software and media is authorized only  *
' *   pursuant to a valid written license from Fast Corporation.  *
' *                                                               *
' *****************************************************************

' -----------------------------------------------------------------
' FVIL Sample Program
' C_CAO
'
' 쐬 : N.Moriguchi
'
'  : 2010/07/22 
'
' FVC05 2ch only Sample Program
' -----------------------------------------------------------------
Public Class Form_FVC05_2CHSAMPLE

    Private m_image_CH0 As FVIL.Data.CFviImage = New FVIL.Data.CFviImage()          'CH0p摜i[̈
    Private m_image_CH1 As FVIL.Data.CFviImage = New FVIL.Data.CFviImage()          'CH1p摜i[̈
    Private m_image_CH0BIN As FVIL.Data.CFviImage = New FVIL.Data.CFviImage()       '2lCH0p摜i[̈
    Private m_image_CH1BIN As FVIL.Data.CFviImage = New FVIL.Data.CFviImage()       '2lCH1p摜i[̈
    Private m_video As FVIL.Video.CFviVideoFVC05 = New FVIL.Video.CFviVideoFVC05    'FVC05NX
    Private m_timer As FVIL.CFviTimeCounter = New FVIL.CFviTimeCounter()            'ԌvNX

    Dim intErr As Integer                                                           'G[ԍi[ϐ
    Public m_strIniFilePath As String                                               'init@CitpXj

    Private m_flgVideoOpened As Boolean                                             'rfIfoCX̃I[v
    Private m_flgFreerun As Boolean                                                 't[̏

    Private Sub FormMainLoad(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        'FVIL̏
        'AvP[VNA ̊֐ĂяoăCuĂB 
        '̎ACZX̔F؂s܂BpԒłĂȀ͕KsKvL܂B 
        'sȂꍇ́AveNgꂽNX̎sł܂B
        FVIL._SetUp.InitVisionLibrary()

        'ԕϐ̏
        m_flgVideoOpened = False
        m_flgFreerun = False

        'vԃeLXg{bNX
        TextBoxTime.Text = "0"

        '`lR{{bNX
        ComboBoxChannel.Items.Clear()
        ComboBoxChannel.Items.Add("CH0 - CH1")
        ComboBoxChannel.SelectedIndex = 0

        'gK[hR{{bNX
        ComboBoxTrigger.Items.Clear()
        ComboBoxTrigger.Items.Add("m[}")
        ComboBoxTrigger.Items.Add("gK")
        ComboBoxTrigger.Items.Add("OgK")
        ComboBoxTrigger.SelectedIndex = 0

        'QlR{{bNX
        ComboBoxBinarize.Items.Clear()
        ComboBoxBinarize.Items.Add("OC")
        ComboBoxBinarize.Items.Add("l")
        ComboBoxBinarize.Items.Add("OC / l")
        ComboBoxBinarize.SelectedIndex = 0

    End Sub

    ''' <summary>
    ''' tH[\Jn Cxgnh
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' gpmF܂B
    ''' </remarks>
    Private Sub formMain_Shown(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Shown
        'gp̊mF
        Dim licence_dialog As New dialogLicence
        If (licence_dialog.ShowDialog(Me) <> DialogResult.OK) Then
            Me.Close() 'gpȂꍇ̓TvvO̓I
            Exit Sub
        End If

        'init@CI
        fnSetIniFile()

        '`imagẽZbg
        CFviImageViewCH0.Image = Me.m_image_CH0
        CFviImageViewCH1.Image = Me.m_image_CH1
        CFviImageViewCH0BIN.Image = Me.m_image_CH0BIN
        CFviImageViewCH1BIN.Image = Me.m_image_CH1BIN

    End Sub

    ''' <summary>
    ''' I
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' AvP[VIB
    ''' </remarks>
    Private Sub FormMainFormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
        'rfIfoCXI[vĂꍇ̓N[Y
        If (m_flgVideoOpened = True) Then
            m_video.Close()
            m_flgVideoOpened = False
        End If

    End Sub

    ''' <summary>
    ''' init@CI֐
    ''' </summary>
    ''' <remarks>
    ''' init@C̑I܂B
    ''' </remarks>
    Private Sub fnSetIniFile()

        Dim formbroseini As New Form_BROWSEINI  'init@Cݒ

        'init@C̑I
        m_strIniFilePath = ""
        If (Form_BROWSEINI.ShowDialog(Me) = DialogResult.OK) Then
            m_strIniFilePath = Form_BROWSEINI.strIniFilePath
        End If

        If (m_strIniFilePath.Length > 0) Then
            Try
                'rfIfoCXI[vĂꍇ̓N[Y
                If (m_video.IsOpen = True) Then
                    m_video.Close()
                    m_flgVideoOpened = False
                End If

                'foCXI[v
                m_video.Open(-1, 0)
                m_flgVideoOpened = True

                'VideoConfFile̕ύXAOpenDevicesƁAgK[[h̕ύX܂
                'ЃLv`{[h̓gK[[h̐ݒɃZbgAbv^CKvɂȂ܂
                '{vÕZbgAbv^C͕Kvőlł350msݒ肵Ă܂B
                'Lv`{[hɂĂ̎Ԃ͈قȂ܂B
                Threading.Thread.Sleep(350)

                'QJ荞݂ɐݒ
                m_video.SimGrab = 2

                'init@CR|[lgɐݒ
                If (m_strIniFilePath.Length > 0) Then
                    m_video.LoadIniFile(m_strIniFilePath)
                End If

                '捞摜𐳋K
                m_video.ChangeImageSize(m_image_CH0)
                m_video.ChangeImageSize(m_image_CH1)
                m_video.ChangeImageSize(m_image_CH0BIN)
                m_video.ChangeImageSize(m_image_CH1BIN)

                'Xe[^X\̍XV
                'gK[h̎擾
                ComboBoxTrigger.SelectedIndex = m_video.Trigger
                'JIԂ̎擾
                NumericUpDownExposure.Value = m_video.ExposureTime

                'e`l̃Xe[^X擾
                'rfI̓ItZbg(CH0)̎擾
                NumericUpDownOffsetCH0.Value = m_video.VideoOffsetCH0
                'Ql臒l(CH0)̎擾
                NumericUpDownThresholdCH0.Value = m_video.BinarizeCH0.Threshold
                'rfI̓ItZbg(CH1)̎擾
                NumericUpDownOffsetCH1.Value = m_video.VideoOffsetCH1
                'Ql臒l(CH1)̎擾
                NumericUpDownThresholdCH1.Value = m_video.BinarizeCH1.Threshold

                'Qlݒ(CH0)̎擾
                ComboBoxBinarize.SelectedIndex = m_video.BinarizeCH0.Mode

            Catch ex As Exception
                'G[
                intErr = m_video.ErrorCode
                MessageBox.Show("ErrorCode= " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End Try

        Else
            'init@CȈꍇ̓TvvO̓I
            Me.Close()
            Exit Sub
        End If

    End Sub

    ''' <summary>
    ''' Grab One{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' J荞݁B
    ''' </remarks>
    Private Sub ButtonGrabOne_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonGrabOne.Click

        Dim msec As Double

        Try
            'ԑJn
            m_timer.Start()
            'J荞
            Select Case ComboBoxBinarize.SelectedIndex
                Case 0     'OC
                    m_video.GrabImageSync(Me.m_image_CH0, Me.m_image_CH1)
                Case 1      'Ql
                    m_video.GrabImageSync(Me.m_image_CH0BIN, Me.m_image_CH1BIN)
                Case 2      'OC / l
                    m_video.GrabImageSync(Me.m_image_CH0, Me.m_image_CH1, Me.m_image_CH0BIN, Me.m_image_CH1BIN)
            End Select
            'ԑI
            msec = m_timer.Stop()
            '莞ԕ\
            TextBoxTime.Text = msec.ToString("0.000")
            'ĕ`
            CFviImageViewCH0.Refresh()
            CFviImageViewCH1.Refresh()
            CFviImageViewCH0BIN.Refresh()
            CFviImageViewCH1BIN.Refresh()
        Catch ex As Exception
            'G[
            intErr = m_video.ErrorCode
            MessageBox.Show("ErrorCode= " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' Grab Continue{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' t[JnE~B
    ''' </remarks>
    Private Sub ButtonGrabContinue_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonGrabContinue.Click

        '{^\ύX
        If (m_flgFreerun = True) Then
            ButtonGrabContinue.Text = "Grab Continue"
            ButtonGrabOne.Enabled = True
            m_flgFreerun = False
            Timer1.Enabled = False
        Else
            ButtonGrabContinue.Text = "Stop"
            ButtonGrabOne.Enabled = False
            m_flgFreerun = True
            Timer1.Interval = 100
            Timer1.Start()
        End If
        Application.DoEvents()

    End Sub

    ''' <summary>
    ''' t[
    ''' </summary>
    ''' <remarks>
    ''' AJ荞݁B
    ''' </remarks>
    Private Sub Timer1Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick

        Dim msec As Double

        Timer1.Stop()

        Try
            If (m_flgVideoOpened = True) Then
                m_timer.Start()                            'ԑJn
                Select Case ComboBoxBinarize.SelectedIndex
                    Case 0     'OC
                        m_video.GrabImageSync(Me.m_image_CH0, Me.m_image_CH1)
                    Case 1      'Ql
                        m_video.GrabImageSync(Me.m_image_CH0BIN, Me.m_image_CH1BIN)
                    Case 2      'OC / l
                        m_video.GrabImageSync(Me.m_image_CH0, Me.m_image_CH1, Me.m_image_CH0BIN, Me.m_image_CH1BIN)
                End Select
                msec = m_timer.Stop()                      'ԑI
                TextBoxTime.Text = msec.ToString("0.000")  '莞ԕ\
                'ĕ`
                CFviImageViewCH0.Refresh()
                CFviImageViewCH1.Refresh()
                CFviImageViewCH0BIN.Refresh()
                CFviImageViewCH1BIN.Refresh()
            End If
            Timer1.Enabled = True

        Catch ex As Exception
            ButtonGrabContinue.Text = "Grab Continue"
            ButtonGrabOne.Enabled = True
            m_flgFreerun = False
            Timer1.Enabled = False

            'G[
            intErr = m_video.ErrorCode
            MessageBox.Show("ErrorCode= " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' `lݒR{{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' `l̑I
    ''' </remarks>
    Private Sub ComboBoxChannel_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxChannel.SelectedIndexChanged
        Try
            If (m_flgVideoOpened = True) Then
                m_video.InputChannel = ComboBoxChannel.SelectedIndex
            End If
        Catch ex As Exception
            'G[
            intErr = m_video.ErrorCode
            MessageBox.Show("ErrorCode= " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    ''' <summary>
    ''' Trigger ModeR{{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' m[}[hEgK[hEOgK[h̑IB
    ''' </remarks>
    Private Sub ComboBoxTrigger_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxTrigger.SelectedIndexChanged, ComboBoxTrigger.SelectedIndexChanged
        Try
            If (m_flgVideoOpened = True) Then
                m_video.Trigger = ComboBoxTrigger.SelectedIndex
                'ЃLv`{[h̓gK[[h̐ݒɃZbgAbv^CKvɂȂ܂
                '{vÕZbgAbv^C͕Kvőlł350msݒ肵Ă܂B
                'Lv`{[hɂĂ̎Ԃ͈قȂ܂B
                Threading.Thread.Sleep(350)
            End If
        Catch ex As Exception
            'G[
            intErr = m_video.ErrorCode
            MessageBox.Show("ErrorCode= " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    ''' <summary>
    ''' Exposure NumericUpDown
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' JIԂ̐ݒB
    ''' </remarks>
    Private Sub ExposureValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDownExposure.ValueChanged, NumericUpDownExposure.ValueChanged
        Try
            If (m_flgVideoOpened = True) Then
                m_video.ExposureTime = NumericUpDownExposure.Value
            End If
        Catch ex As Exception
            'G[
            intErr = m_video.ErrorCode
            MessageBox.Show("ErrorCode= " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' Offset CH0 NumericUpDown
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ItZbg(CH0)̐ݒB
    ''' </remarks>
    Private Sub NumericUpDownOffsetCH0_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDownOffsetCH0.ValueChanged
        Try
            If (m_flgVideoOpened = True) Then
                '`lOɐݒ
                m_video.VideoOffsetCH0 = NumericUpDownOffsetCH0.Value
            End If
        Catch ex As Exception
            'G[
            intErr = m_video.ErrorCode
            MessageBox.Show("ErrorCode= " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    ''' <summary>
    ''' Offset CH1 NumericUpDown
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ItZbg(CH1)̐ݒB
    ''' </remarks>
    Private Sub NumericUpDownOffsetCH1_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDownOffsetCH1.ValueChanged
        Try
            If (m_flgVideoOpened = True) Then
                '`lPɐݒ
                m_video.VideoOffsetCH1 = NumericUpDownOffsetCH1.Value
            End If
        Catch ex As Exception
            'G[
            intErr = m_video.ErrorCode
            MessageBox.Show("ErrorCode= " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    ''' <summary>
    ''' Binarize ComboBox
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' Ql捞ݒ
    ''' </remarks>
    Private Sub ComboBoxBinarize_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxBinarize.SelectedIndexChanged
        Try
            If (m_flgVideoOpened = True) Then
                Dim bin As FVIL.Video.CFviVideoBinarize = m_video.Binarize
                'Qlݒ胂[h OC / l I͓lݒ
                If (ComboBoxBinarize.SelectedIndex < 2) Then
                    bin.Mode = ComboBoxBinarize.SelectedIndex
                Else
                    bin.Mode = 1
                End If
                'QJȂ̂ŗɐݒ
                m_video.BinarizeCH0 = bin
                m_video.BinarizeCH1 = bin
                '捞摜𐳋K
                If (bin.Mode <> 0) Then
                    m_video.ChangeImageSize(m_image_CH0BIN)
                    m_video.ChangeImageSize(m_image_CH1BIN)
                End If
            End If
        Catch ex As Exception
            'G[
            intErr = m_video.ErrorCode
            MessageBox.Show("ErrorCode= " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' Threshold CH0 NumericUpDown
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' 2ll(CH0)̐ݒ
    ''' </remarks>
    Private Sub NumericUpDownThresholdCH0_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDownThresholdCH0.ValueChanged
        Try
            If (m_flgVideoOpened = True) Then
                Dim bin As FVIL.Video.CFviVideoBinarize = m_video.Binarize
                bin.Threshold = NumericUpDownThresholdCH0.Value
                '`lOɐݒ
                m_video.BinarizeCH0 = bin
            End If
        Catch ex As Exception
            'G[
            intErr = m_video.ErrorCode
            MessageBox.Show("ErrorCode= " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' Threshold CH1 NumericUpDown
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' 2ll(CH1)̐ݒ
    ''' </remarks>
    Private Sub NumericUpDownThresholdCH1_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDownThresholdCH1.ValueChanged
        Try
            If (m_flgVideoOpened = True) Then
                Dim bin As FVIL.Video.CFviVideoBinarize = m_video.Binarize
                bin.Threshold = NumericUpDownThresholdCH1.Value
                '`lPɐݒ
                m_video.BinarizeCH1 = bin
            End If
        Catch ex As Exception
            'G[
            intErr = m_video.ErrorCode
            MessageBox.Show("ErrorCode= " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' ReLoad Ini File{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' rfIݒpinit@C̍ĐݒB
    ''' </remarks>
    Private Sub ButtonReLoadIni_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonReLoadIni.Click

        't[Ȃ΁A~B
        If (m_flgFreerun = True) Then
            ButtonGrabContinue.Text = "Grab Continue"
            ButtonGrabOne.Enabled = True
            m_flgFreerun = False
            Timer1.Enabled = False
            Application.DoEvents()
        End If

        'init@CI
        fnSetIniFile()

    End Sub

    ''' <summary>
    ''' Save Image{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' \摜ۑ
    ''' </remarks>
    Private Sub ButtonSaveImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonSaveImage.Click

        Dim ofdlg As SaveFileDialog = New SaveFileDialog()
        ofdlg.Filter = "摜t@C(*.bmp;*.dib;*.png;*.jpg;*.jpeg;*.tif;*.tiff;*.raw;*.pat)|*.bmp;*.dib;*.png;*.jpg;*.jpeg;*.tif;*.tiff;*.raw;*.pat"
        ofdlg.Filter += "|Bitmap t@C (*.bmp;*.dib)|*.bmp;*.dib"
        ofdlg.Filter += "|Png t@C (*.png)|*.png"
        ofdlg.Filter += "|Jpeg t@C (*.jpg;*.jpeg)|*.jpg;*.jpeg"
        ofdlg.Filter += "|Tiff t@C (*.tif;*.tiff)|*.tif;*.tiff"
        ofdlg.Filter += "|Raw t@C (*.raw)|*.raw"
        ofdlg.Filter += "|ׂẴt@C (*.*)|*.*"
        ofdlg.OverwritePrompt = True

        Try
            If (ofdlg.ShowDialog(Me) = DialogResult.OK) Then
                Dim name As String
                Dim temp As Integer
                'gq܂ł̕Zo
                temp = ofdlg.FileName.Length - ofdlg.FileName.LastIndexOfAny(".")
                temp = ofdlg.FileName.Length - temp
                If ((ComboBoxBinarize.SelectedIndex = 0) Or (ComboBoxBinarize.SelectedIndex = 2)) Then
                    '̊֐́AȈՓIɉ摜t@C̕ۑŝׂ̂łB 
                    '̊֐ŎwłȂp[^w肷Kv΁A e摜t@CANZXNX𒼐ڎgpĂB 

                    '`lÕOC摜ۑ
                    name = ofdlg.FileName.Insert(temp, "_0Ch")
                    FVIL.File.Function.SaveImageFile(name, CFviImageViewCH1.Image)
                    '`lP̃OC摜ۑ
                    name = ofdlg.FileName.Insert(temp, "_1Ch")
                    FVIL.File.Function.SaveImageFile(name, CFviImageViewCH1.Image)

                    'ۑt@C`Œ̏ꍇ́Aȉ̂悤ɋLq܂B
                    '1) bmpt@C̏ꍇ
                    'Dim file As FVIL.File.CFviImageFileBmp = New FVIL.File.CFviImageFileBmp()
                    'file.Save(ofdlg.FileName, m_image)

                    '2) jpgt@C̏ꍇ
                    'Dim file As FVIL.File.CFviImageFileJpg = New FVIL.File.CFviImageFileJpg()
                    'file.Save(ofdlg.FileName, m_image)
                End If
                If ((ComboBoxBinarize.SelectedIndex = 1) Or (ComboBoxBinarize.SelectedIndex = 2)) Then
                    '`lO̓l摜ۑ
                    name = ofdlg.FileName.Insert(temp, "_0ChBin")
                    FVIL.File.Function.SaveImageFile(name, CFviImageViewCH0BIN.Image)
                    '`lP̓l摜ۑ
                    name = ofdlg.FileName.Insert(temp, "_1ChBin")
                    FVIL.File.Function.SaveImageFile(name, CFviImageViewCH1BIN.Image)
                End If
            End If
        Catch ex As FVIL.CFviException
            Dim msg As System.String = System.String.Format("CuO𔭍s܂Bcode={0} func={1}", ex.ErrorCode, ex.Function)
            Select Case (ex.ErrorCode)
                Case FVIL.ErrorCode.NOT_SUPPORTED, _
                 FVIL.ErrorCode.INVALID_OBJECT
                    msg += vbCrLf + "T|[gĂȂ摜IuWFNgłB"
                    msg += vbCrLf + "Raw `ŕۑĂB"
            End Select
            MessageBox.Show(msg, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' x1{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' {ŕ\܂B
    ''' </remarks>
    Private Sub ButtonMag1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonMag1.Click

        '摜̕\{̎擾܂͐ݒs܂B1.0Ǝw肷Ɠ{ŕ\܂B
        '{ĺA0.5Ƃꍇ́AE1/2ƂȂAʐς1/4ɂȂ܂B
        '3.0Ƃꍇ́AE3{ƂȂAʐς9{ɂȂ܂B
        '\{̐ݒ
        CFviImageViewCH0.Display.Magnification = 1.0
        CFviImageViewCH1.Display.Magnification = 1.0
        CFviImageViewCH0BIN.Display.Magnification = 1.0
        CFviImageViewCH1BIN.Display.Magnification = 1.0
        'ĕ`
        CFviImageViewCH0.Refresh()
        CFviImageViewCH1.Refresh()
        CFviImageViewCH0BIN.Refresh()
        CFviImageViewCH1BIN.Refresh()

    End Sub

    ''' <summary>
    ''' Fit{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' 摜Ŝr[̃NCAg̈ɕ\ł悤ɕ\{k(܂͊g)܂
    ''' </remarks>
    Private Sub ButtonFit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonFit.Click

        '摜Ŝr[̃NCAg̈ɕ\ł悤ɕ\{k(܂͊g)܂
        '\{𒲐
        CFviImageViewCH0.FitImageSize()
        CFviImageViewCH1.FitImageSize()
        CFviImageViewCH0BIN.FitImageSize()
        CFviImageViewCH1BIN.FitImageSize()
        'ĕ`
        CFviImageViewCH0.Refresh()
        CFviImageViewCH1.Refresh()
        CFviImageViewCH0BIN.Refresh()
        CFviImageViewCH1BIN.Refresh()

    End Sub

    ''' <summary>
    ''' {{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ݂̔{0.5{ŕ\܂B
    ''' </remarks>
    Private Sub ButtonPlus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonPlus.Click

        Dim Value As Double
        '{̎擾
        Value = CFviImageViewCH0.Display.Magnification
        '\{̐ݒ
        Value = Value + 0.5
        CFviImageViewCH0.Display.Magnification = Value
        CFviImageViewCH1.Display.Magnification = Value
        CFviImageViewCH0BIN.Display.Magnification = Value
        CFviImageViewCH1BIN.Display.Magnification = Value
        'ĕ`
        CFviImageViewCH0.Refresh()
        CFviImageViewCH1.Refresh()
        CFviImageViewCH0BIN.Refresh()
        CFviImageViewCH1BIN.Refresh()

    End Sub

    ''' <summary>
    ''' |{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ݂̔{0.5{ŕ\܂BA{OȉɂȂꍇ͔{0.1ŕ\܂B
    ''' </remarks>
    Private Sub ButtonMinus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonMinus.Click

        Dim Value As Double
        '{̎擾
        Value = CFviImageViewCH0.Display.Magnification
        '\{̐ݒ
        Value = Value - 0.5
        If (Value <= 0) Then
            Value = 0.1       'Oȉݒ肷ƃG[ɂȂ̂0.1ݒ肷
        End If
        CFviImageViewCH0.Display.Magnification = Value
        CFviImageViewCH1.Display.Magnification = Value
        CFviImageViewCH0BIN.Display.Magnification = Value
        CFviImageViewCH1BIN.Display.Magnification = Value
        'ĕ`
        CFviImageViewCH0.Refresh()
        CFviImageViewCH1.Refresh()
        CFviImageViewCH0BIN.Refresh()
        CFviImageViewCH1BIN.Refresh()

    End Sub

    ''' <summary>
    ''' Ascope`FbN{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ASCOPE̕\ؑւ܂B
    ''' </remarks>
    Private Sub CheckBoxAScope_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBoxAscope.CheckedChanged

        'ASCOPEI[oC̐ݒ
        If (CheckBoxAscope.CheckState) Then
            'ASCOPE̕\LɂB
            CFviImageViewCH0.Display.OverlayAscope.Enable = True
            CFviImageViewCH0.Display.OverlayAscope.Active = True
            CFviImageViewCH1.Display.OverlayAscope.Enable = True
            CFviImageViewCH1.Display.OverlayAscope.Active = True
            CFviImageViewCH0BIN.Display.OverlayAscope.Enable = True
            CFviImageViewCH0BIN.Display.OverlayAscope.Active = True
            CFviImageViewCH1BIN.Display.OverlayAscope.Enable = True
            CFviImageViewCH1BIN.Display.OverlayAscope.Active = True
        Else
            'ASCOPE̕\𖳌ɂB
            CFviImageViewCH0.Display.OverlayAscope.Enable = False
            CFviImageViewCH0.Display.OverlayAscope.Active = False
            CFviImageViewCH1.Display.OverlayAscope.Enable = False
            CFviImageViewCH1.Display.OverlayAscope.Active = False
            CFviImageViewCH0BIN.Display.OverlayAscope.Enable = False
            CFviImageViewCH0BIN.Display.OverlayAscope.Active = False
            CFviImageViewCH1BIN.Display.OverlayAscope.Enable = False
            CFviImageViewCH1BIN.Display.OverlayAscope.Active = False
        End If
        'ĕ`
        CFviImageViewCH0.Refresh()
        CFviImageViewCH1.Refresh()
        CFviImageViewCH0BIN.Refresh()
        CFviImageViewCH1BIN.Refresh()

    End Sub

End Class
